// contextmenu.h

#ifndef _CONTEXTMENU_H_
#define _CONTEXTMENU_H_

// This struct acts somewhat like a pseudo class in that you have
// variables accociated with an instance of the interface.
typedef struct _ContextMenuExtStruct
{
	// Two interfaces
	IContextMenu   cm;  // It is important that nothing comes before the
	IShellExtInit  si;  // IContextMenu and IShellExtInit interfaces.
	
	// second part of the struct for the variables
	LPTSTR  m_pszSource;
	ULONG   m_ulRef;
}ContextMenuExtStruct;

// IContextMenu methods forward declaration
STDMETHODIMP         CContextMenuExt_QueryInterface(IContextMenu*,REFIID,LPVOID *);
STDMETHODIMP_(ULONG) CContextMenuExt_AddRef(IContextMenu*);
STDMETHODIMP_(ULONG) CContextMenuExt_Release(IContextMenu*);
STDMETHODIMP         CContextMenuExt_QueryContextMenu(IContextMenu*,HMENU,UINT,UINT,UINT,UINT);
STDMETHODIMP         CContextMenuExt_InvokeCommand(IContextMenu*, LPCMINVOKECOMMANDINFO);
STDMETHODIMP         CContextMenuExt_GetCommandString(IContextMenu*,UINT,UINT,UINT*,LPSTR,UINT);

// IContextMenu constructor
IContextMenu *       CContextMenuExt_Create(void);

// IShellExtInit methods forward declarations
STDMETHODIMP         CShellInitExt_QueryInterface(IShellExtInit*,REFIID,LPVOID*);
STDMETHODIMP_(ULONG) CShellInitExt_AddRef(IShellExtInit*);
STDMETHODIMP_(ULONG) CShellInitExt_Release(IShellExtInit*);
STDMETHODIMP         CShellInitExt_Initialize(IShellExtInit*,LPCITEMIDLIST,LPDATAOBJECT,HKEY);

#endif // _CONTEXTMENU_H_


